unit demo1_main;
{
   TUTPackage unit demo

   Shows:
    * Open a package and list exported objects.
    * Read objects.
    * Show object properties.
    * Save Textures and TextBuffers.
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ut_packages;

type
  Tmain = class(TForm)
    object_list: TListView;
    btn_open: TButton;
    btn_extract: TButton;
    OpenDialog1: TOpenDialog;
    properties: TListView;
    procedure btn_openClick(Sender: TObject);
    procedure object_listSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure btn_extractClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    package:TUTPackage;
    obj:TUTObject;
  public
    { Public declarations }
  end;

var
  main: Tmain;

implementation

{$R *.DFM}

procedure Tmain.btn_openClick(Sender: TObject);
var n:integer;
begin
     if opendialog1.execute then
        begin
        object_list.items.clear;
        properties.items.clear;
        package.initialize (opendialog1.filename);
        obj:=nil;
        object_list.items.clear;
        for n:=0 to package.ExportedCount-1 do
            with object_list.items.add do
                 begin
                 caption:=package.Exported[n].UTObjectName;
                 subitems.add (package.Exported[n].UTClassName);
                 data:=pointer(n);
                 end;
        end;
end;

procedure Tmain.object_listSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
var p:integer;
begin
     if item=nil then exit;
     btn_extract.enabled:=(item.SubItems[0]='Texture') or (item.SubItems[0]='TextBuffer');
     if obj<>nil then obj.ReleaseObject;
     obj:=package.Exported[integer(item.Data)].UTObject; // The object is created at this time
     if obj=nil then exit;
     obj.ReadObject;
     properties.items.clear;
     for p:=0 to obj.Properties.Count-1 do
         with properties.items.add do
              caption:=obj.Properties.PropertyByPosition[p].Description;
end;

procedure Tmain.btn_extractClick(Sender: TObject);
begin
     if object_list.Selected.subitems[0]='Texture' then
        begin
        TUTObjectClassTexture(obj).MipMap[0].AsBitmap.SaveToFile (extractfilepath(application.exename)+object_list.Selected.caption+'.bmp');
        end
     else if object_list.Selected.subitems[0]='TextBuffer' then
        begin
        TUTObjectClassTextBuffer(obj).SaveToFile (extractfilepath(application.exename)+object_list.Selected.caption+'.txt');
        end;
end;

procedure Tmain.FormCreate(Sender: TObject);
begin
     Register2DClasses;
     RegisterCodeClasses;
     package:=TUTPackage.create;
end;

procedure Tmain.FormDestroy(Sender: TObject);
begin
     object_list.items.clear;
     package.free;
end;

end.
