program ExtractTextures;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Classes,
  ut_packages;

var
  sr:TSearchRec;d,e,n:integer;
  package:TUTPackage;
  dirs:tstringlist;directory,fname:string;

begin
  writeln ('ExtractTextures v1.0');
  writeln;
  writeln ('Usage: ExtractTextures <directory> [<directory>...]');
  writeln;

  dirs:=tstringlist.create;

  directory:=IncludeTrailingBackslash(getcurrentdir);
  for e:=1 to paramcount do
    dirs.add (IncludeTrailingBackslash(paramstr(e)));
  if dirs.count=0 then dirs.add (directory);

  Register2DClasses;

  for d:=0 to dirs.count-1 do
    begin
      writeln ('Searching directory for packages '+dirs[d]);
      e:=findfirst (dirs[d]+'*.u*',faAnyFile-faDirectory-faVolumeId,sr);
      while e=0 do
        begin
          package:=TUTPackage.create;
          try
            writeln ('Analyzing package '+dirs[d]+sr.name+'...');
            package.initialize (dirs[d]+sr.name);
            for n:=0 to package.ExportedCount-1 do
              begin
                if GetUTObjectClass(package.Exported[n].UTClassName).InheritsFrom(TUTObjectClassTexture) then
                  begin
                    package.Exported[n].UTObject.ReadObject;
                    fname:=directory+changefileext(sr.name,'')+'\';
                    if package.Exported[n].UTGroupName<>'' then fname:=fname+package.Exported[n].UTGroupName+'\';
                    fname:=fname+package.Exported[n].UTObjectName+'.bmp';
                    write ('   Extracting texture '+package.Exported[n].UTObjectName+'... ');
                    forcedirectories(extractfilepath(fname));
                    try
                      TUTObjectClassTexture(package.Exported[n].UTObject).GoodMipMap[0].AsBitmap.savetofile (fname);
                      writeln ('OK');
                    except
                      on e:exception do
                        writeln (e.message);
                    end;
                    package.Exported[n].UTObject.ReleaseObject;
                  end;
              end;
          except
            on e:exception do
              writeln ('   '+e.message);
          end;
          package.free;
          e:=findnext(sr);
        end;
      findclose(sr);
    end;

  dirs.free;
end.
 