unit gn_main;
{

}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls, ExtCtrls;

type
    TFuncionNativa=record
      Index:integer;
      Format:shortstring;
      OperatorPrecedence:byte;
      Name:shortstring;
      package:shortstring;
    end;
    TArrayNativas=array of TFuncionNativa;

type
  Tmain = class(TForm)
    Memo: TMemo;
    MainMenu1: TMainMenu;
    mnu_Generador: TMenuItem;
    mnu_Desde_DirectoriodePaquetes: TMenuItem;
    OpenDialog1: TOpenDialog;
    StatusBar: TStatusBar;
    N1: TMenuItem;
    mnu_Salir: TMenuItem;
    mnu_Generatecombinedarray: TMenuItem;
    mnu_Loadgameprofile: TMenuItem;
    Splitter1: TSplitter;
    lista_juegos: TListBox;
    mnu_Checkconflicts: TMenuItem;
    procedure mnu_Desde_DirectoriodePaquetesClick(Sender: TObject);
    procedure mnu_SalirClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnu_LoadgameprofileClick(Sender: TObject);
    procedure mnu_GeneratecombinedarrayClick(Sender: TObject);
    procedure mnu_CheckconflictsClick(Sender: TObject);
  private
    { Private declarations }
    juegos:array of TArrayNativas;
    procedure LoadGameProfile(filename: string);
    procedure SaveGameProfile(juego: integer; filename: string);
  public
    { Public declarations }
  end;

var
  main: Tmain;

implementation

{$R *.DFM}

uses system2,ut_packages;

procedure Tmain.LoadGameProfile (filename:string);
var n,a:integer;f:file;
begin
     assignfile (f,filename);
     reset(f,1);
     blockread(f,n,4);
     setlength (juegos,length(juegos)+1);
     setlength (juegos[high(juegos)],n);
     for a:=0 to n-1 do
         blockread (f,juegos[high(juegos)][a],sizeof(TFuncionNativa));
     closefile(f);
     lista_juegos.items.add (changefileext(extractfilename(filename),''));
end;

procedure Tmain.SaveGameProfile (juego:integer;filename:string);
var n,a:integer;f:file;
begin
     assignfile (f,filename);
     rewrite(f,1);
     n:=length(juegos[juego]);
     blockwrite(f,n,4);
     for a:=0 to n-1 do
         blockwrite (f,juegos[juego][a],sizeof(TFuncionNativa));
     closefile(f);
end;

procedure Tmain.mnu_Desde_DirectoriodePaquetesClick(Sender: TObject);
var nombre,formato,indice,directorio,msg,nombre_juego:string;obj:TUTObjectClassFunction;
    precedence,e,a,cuenta:integer;sr:tsearchrec;package:TUTPackage;
begin
  memo.lines.clear;
  cursor:=crHourglass;
  enabled:=false;
  nombre_juego:=inputbox ('Read Game Natives','Game name (filename for profile)?','ut');
  with opendialog1 do
       begin
       title:='Select any package file in the System directory';
       filter:='Package files|*.u|All files|*.*';
       filename:='';
       if execute then
         begin
           memo.lines.add ('Checking directory '+extractfilepath(opendialog1.filename));
           setlength(juegos,length(juegos)+1);
           lista_juegos.items.add (nombre_juego);
           setlength(juegos[high(juegos)],1000);
           cuenta:=0;
           directorio:=extractfilepath(opendialog1.filename);
           e:=findfirst (directorio+'*'+extractfileext(opendialog1.filename),faAnyFile,sr);
           while e=0 do
                 begin
                 statusbar.simpletext:=sr.name;
                 memo.lines.add ('  '+sr.name);
                 application.processmessages;
                 package:=TUTPackage.create;
                 package.Initialize(sr.name);
                 for a:=0 to package.ExportedCount-1 do
                     if lowercase(package.Exported[a].UTClassName)='function' then
                        begin
                        obj:=TUTObjectClassFunction(package.Exported[a].UTObject);
                        obj.UTClassName;
                        try
                          obj.ReadObject;
                        except
                          on e:exception do
                             begin
                             msg:=format('Exception in function %s.%s'#13#10+e.message,[extractfilename(sr.name),package.Exported[a].UTobjectname]);
                             memo.lines.add (msg);
                             //application.messagebox (pchar(msg),'ERROR',mb_ok);
                             end;
                        end;
                        if ((obj.functionflags and FUNC_Native)<>0) and
                           ((obj.functionflags and FUNC_Event)=0){ and
                           (obj.NativeIndex<>0)} then
                           begin
                           indice:=inttostr(obj.NativeIndex);
                           precedence:=obj.OperatorPrecedence;
                           //if precedence=0 then precedence:=255;
                           nombre:=obj.friendlyname;
                           if (obj.functionflags and FUNC_Operator)<>0 then
                              begin
                              if (obj.functionflags and FUNC_PreOperator)<>0 then
                                 formato:='nffPreOperator'
                              else if precedence=0 then
                                 formato:='nffPostOperator'
                              else
                                 formato:='nffOperator';
                              end
                           else
                              formato:='nffFunction';
                           if cuenta>high(juegos[high(juegos)]) then setlength(juegos[high(juegos)],length(juegos[high(juegos)])*2);
                           with juegos[high(juegos)][cuenta] do
                                begin
                                index:=strtointdef(indice,-1);
                                format:=formato;
                                operatorprecedence:=precedence;
                                name:=nombre;
                                package:=extractfilename(sr.name);
                                end;
                           inc(cuenta);
                           end;
                        obj.ReleaseObject;
                        end;
                 package.free;
                 e:=findnext(sr);
                 end;
           findclose(sr);
           statusbar.simpletext:='';
           setlength(juegos[high(juegos)],cuenta);
           SaveGameProfile (high(juegos),extractfilepath(application.exename)+nombre_juego+'.gpr');
           memo.lines.add ('Saved game profile '+extractfilepath(application.exename)+nombre_juego+'.gpr');
           memo.lines.add ('End.');
         end;
       end;
  cursor:=crDefault;
  enabled:=true;
end;

procedure Tmain.mnu_SalirClick(Sender: TObject);
begin
     close;
end;

procedure Tmain.FormCreate(Sender: TObject);
begin
     RegisterCodeClasses;
end;

procedure Tmain.mnu_LoadgameprofileClick(Sender: TObject);
begin
     with opendialog1 do
          begin
          Title:='Select game profile';
          filter:='Game profile files|*.gpr';
          filename:='*.gpr';
          if execute then LoadGameProfile (filename);
          end;
end;

procedure Tmain.mnu_GeneratecombinedarrayClick(Sender: TObject);
var nativas:TArrayNativas;j1,n1,n2:integer;ok:boolean;
  procedure ordenar_natives;
  var a,b:integer;tmp:TFuncionNativa;
  begin
       for a:=0 to high(nativas)-1 do
           for b:=a+1 to high(nativas) do
               if ((nativas[a].index=0) and (nativas[b].index<>0)) or
                  ((nativas[b].index<>0) and (nativas[a].index>nativas[b].index)) or
                  ((nativas[a].index=nativas[b].index) and (nativas[a].package>nativas[b].package)) or
                  ((nativas[a].index=nativas[b].index) and (nativas[a].package=nativas[b].package) and (nativas[a].name>nativas[b].name)) then
                  begin
                  tmp:=nativas[a];
                  nativas[a]:=nativas[b];
                  nativas[b]:=tmp;
                  end;
  end;
  procedure construye_listado;
  var codigo,comentario:string;a,cuenta,last_index:integer;alguna_repetida{,algun_noindex}:boolean;
  begin
       ordenar_natives;
       last_index:=-2;alguna_repetida:=false;//algun_noindex:=false;
       codigo:='';cuenta:=0;
       for a:=0 to high(nativas) do
           begin
           comentario:=' // '+nativas[a].package;
           if nativas[a].index=last_index then
              begin
              comentario:=comentario+' ; Repeated index!!!';
              alguna_repetida:=true;
              end;
           {else if nativas[a].index=0 then
              begin
              algun_noindex:=true;
              end;}
           if a<high(nativas) then
              comentario:=','+comentario
           else
              comentario:=' '+comentario;
           if nativas[a].index>0 then
              begin
              codigo:=codigo+format('    {%4.4d} (Index:%5.5d;Format:%-15s;OperatorPrecedence:%3.3d;Name:%-25s)%s'#13#10,
                                    [cuenta,nativas[a].index,nativas[a].format,nativas[a].OperatorPrecedence,''''+nativas[a].name+'''',comentario]);
              inc(cuenta);
              last_index:=nativas[a].index;
              end
           else
              last_index:=-2;
           end;
       codigo:=format('  NativeFunctions_: array[0..%d] of TNativeFunction = ('#13#10,[cuenta-1])+codigo+'    );';
       memo.lines.text:=codigo;
       if alguna_repetida then application.messagebox ('At least one index is repeated!'#13#10'Search it in the comments.','WARNING',mb_ok);
       //if algun_noindex then application.messagebox ('At least one function does not have an index!','WARNING',mb_ok);
  end;
begin
     cursor:=crHourglass;
     enabled:=false;
     setlength(Nativas,length(juegos[0]));
     for n1:=0 to high(juegos[0]) do
         begin
         nativas[n1]:=juegos[0][n1];
         nativas[n1].package:=nativas[n1].package+' ('+lista_juegos.items[0]+')';
         end;
     for j1:=1 to high(juegos) do // por cada juego (excepto el primero)
         for n1:=0 to high(juegos[j1]) do // por cada funcion de ese juego
             if (juegos[j1][n1].index<>0) then
                begin
                // comprobamos si ya esta presente
                ok:=true;
                n2:=0;
                while ok and (n2<=high(nativas)) do
                      if (juegos[j1][n1].index=nativas[n2].index) and
                         (juegos[j1][n1].name=nativas[n2].name) and
                         (juegos[j1][n1].format=nativas[n2].format) and
                         (juegos[j1][n1].operatorprecedence=nativas[n2].operatorprecedence) then
                         ok:=false
                      else
                         inc(n2);
                if ok then
                   begin // aun no ha sido insertada
                   setlength(Nativas,length(nativas)+1);
                   nativas[high(nativas)]:=juegos[j1][n1];
                   nativas[high(nativas)].package:=nativas[high(nativas)].package+' ('+lista_juegos.items[j1]+')';
                   end
                else
                   nativas[n2].package:=nativas[n2].package+', '+juegos[j1][n1].package+' ('+lista_juegos.items[j1]+')';
                end;
     construye_listado;
     enabled:=true;
     cursor:=crDefault;
end;

procedure Tmain.mnu_CheckconflictsClick(Sender: TObject);
var conflictos:tstringlist;j1,j2,n1,n2:integer;ok:boolean;
begin
     cursor:=crHourglass;
     enabled:=false;
     conflictos:=tstringlist.create;
     for j1:=1 to high(juegos) do // por cada juego (excepto el primero)
         for j2:=0 to j1-1 do // se comprueba si choca con los anteriores
             for n1:=0 to high(juegos[j1]) do
                 begin
                 n2:=0;ok:=true;
                 while ok and (n2<=high(juegos[j2])) do
                     begin
                     if (juegos[j2][n2].index=juegos[j1][n1].index) and
                        (juegos[j2][n2].index<>0) and not
                        ((juegos[j2][n2].format=juegos[j1][n1].format) and
                         (juegos[j2][n2].operatorprecedence=juegos[j1][n1].operatorprecedence) and
                         (juegos[j2][n2].name=juegos[j1][n1].name){ and
                         (juegos[j2][n2].package=juegos[j1][n1].package)}) then
                        ok:=false
                     else
                        inc(n2);
                     end;
                 if not ok then
                    begin
                    conflictos.add ('"'+lista_juegos.items[j2]+'".'+juegos[j2][n2].name+
                                    ' conflicts with '+
                                    '"'+lista_juegos.items[j1]+'".'+juegos[j1][n1].name);
                    end;
                 end;
     if conflictos.count=0 then conflictos.add ('No conflicts.');
     conflictos.insert (0,'This test checks if there are any conflicts between games.');
     conflictos.insert (1,'The test only checks that for the same index, the name, format and operator precedence are the same.');
     conflictos.insert (2,'');
     memo.lines.assign(conflictos);
     conflictos.free;
     enabled:=true;
     cursor:=crDefault;
end;

end.
